<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Context.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean</a> &gt; <span class="el_source">Context.java</span></div><h1>Context.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean;

import io.gitlab.littlesaints.protean.analytics.AggregateStatsListener;
import io.gitlab.littlesaints.protean.configuration.Configuration;
import io.gitlab.littlesaints.protean.resources.Registry;
import io.gitlab.littlesaints.protean.throttle.Throttle;

import java.util.function.Function;

/**
 * This represents a complete execution workflow / pipeline.
 * It should be used by the application to retrieve an endpoint using {@link #getEndpoint()}, to submit payloads for execution.
 * &lt;p&gt;
 * It can be built using a {@link Configuration}.
 *
 * @param &lt;P&gt; the getType of payload that'll be submitted.
 * @param &lt;R&gt; the getType of result that will be returned.
 * @author Varun Anand
 * @since 1.0
 */
public interface Context&lt;P, R&gt; {

<span class="fc" id="L43">    Registry&lt;Factory&gt; REGISTRY = new Registry&lt;&gt;();</span>

    interface Factory {
        &lt;E, P, R&gt; Context&lt;P, R&gt; newInstance(String name, Configuration configuration, final AggregateStatsListener&lt;E&gt; statsListener,
                                            final EventExecutor&lt;P, R&gt; executor, final Throttle throttle);
    }

    void shutdown();

    Function&lt;P, R&gt; getEndpoint();

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>